# -*- coding: utf-8 -*-
import sys

from langchain.chains import LLMChain
from langchain.prompts import PromptTemplate

from typing import Awaitable
import asyncio
from langchain.callbacks import AsyncIteratorCallbackHandler
from src.llm.ernie_with_sdk import ChatERNIESerLLM
from qianfan import ChatCompletion

sys.path.append("../..")
prompt1 = """'''
{context}
'''
请你根据上述已知资料回答下面的问题，问题如下：
{question}"""
PROMPT1 = PromptTemplate(input_variables=["context", "question"], template=prompt1)


def chat(context, question):
    base_llm = ChatERNIESerLLM(
        chat_completion=ChatCompletion(ak="pT7sV1smp4AeDl0LjyZuHBV9", sk="b3N0ibo1IKTLZlSs7weZc8jdR0oHjyMu"))
    erniellm = LLMChain(llm=base_llm, prompt=PROMPT1, llm_kwargs={"temperature": 0.9})
    if not context and not question:
        return ""
    result = erniellm.run({"context": context, "question": question})
    return result


async def async_chat_stc(context, question):
    base_llm = ChatERNIESerLLM(
        chat_completion=ChatCompletion(ak="pT7sV1smp4AeDl0LjyZuHBV9", sk="b3N0ibo1IKTLZlSs7weZc8jdR0oHjyMu"))
    erniellm = LLMChain(llm=base_llm, prompt=PROMPT1, llm_kwargs={"temperature": 0.9})
    callback = AsyncIteratorCallbackHandler()

    async def wrap_done(fn: Awaitable, event: asyncio.Event):
        try:
            await fn
        except Exception as e:
            import traceback
            traceback.print_exc()
            print(f"Caught exception: {e}")
        finally:
            event.set()

    task = asyncio.create_task(
        wrap_done(erniellm.arun({"context": context, "question": question}, callbacks=[callback]), callback.done))
    print("*" * 20)
    text = ""
    async for token in callback.aiter():
        text = text + token
        yield f"{text}"
    await task


if __name__ == "__main__":
    print("main函数begin")
    print(chat("当别人想你说你好的时候，你也应该说你好", "你好"))
